"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClozeCrafter = void 0;
const ClozePattern_1 = require("./ClozePattern");
const ClozeTypeEnum_1 = require("./ClozeTypeEnum");
class ClozeCrafter {
    constructor(patterns) {
        this.patterns = patterns.map(patternStr => new ClozePattern_1.ClozePattern(patternStr));
    }
    createClozeNote(text) {
        let noteType = null;
        for (const pattern of this.patterns) {
            const currentType = pattern.getMainClozeType(text);
            if (currentType !== null &&
                (noteType === null ||
                    ClozeTypeEnum_1.ClozeTypesPriority.indexOf(currentType) < ClozeTypeEnum_1.ClozeTypesPriority.indexOf(noteType))) {
                noteType = currentType;
            }
        }
        if (noteType === null) {
            return null;
        }
        const selectedClass = ClozeTypeEnum_1.NoteClassByClozeType[noteType];
        const clozeNote = new selectedClass(text, this.patterns);
        return clozeNote;
    }
}
exports.ClozeCrafter = ClozeCrafter;
