"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClozeNote = void 0;
/**
 * Class ClozeNote
 *
 * This class is not meant to be used directly. It serves as a base implementation
 * for common methods used in other implementations of ClozeNote.
 */
class ClozeNote {
    /**
     * Creates a new ClozeNote instance.
     *
     * @param raw The raw text of the cloze note before processing.
     */
    constructor(raw, patterns) {
        this._raw = raw;
        const { clozeDeletions, numCards } = this.initParsing(raw, patterns);
        this._clozeDeletions = clozeDeletions;
        this._numCards = numCards;
    }
    get raw() {
        return this._raw;
    }
    get numCards() {
        return this._numCards;
    }
}
exports.ClozeNote = ClozeNote;
